//-----------------------------------------------------------------
//MainActivity Class
//メインとなるアクティビティクラス
//Copyright：TOMY
//Ver:1.000
//-----------------------------------------------------------------
package jp.denpa.tomy.games;


import jp.denpa.tomy.opengl_es.wrap.AndroidBgmManager;
import jp.denpa.tomy.opengl_es.wrap.AndroidSoundManager;
import jp.denpa.tomy.opengl_es.wrap.GLTextureManager;
import jp.denpa.tomy.opengl_es.wrap.Global;
import jp.denpa.tomy.opengl_es.wrap.MainRenderer;
import android.app.Activity;
import android.media.AudioManager;
import android.os.Bundle;
import android.view.*;

//Androidアプリ起動クラス
public class  MainActivity extends Activity {

	//描画対象View			（MyViewはGLSurfaceView class を継承している）
	private MyGLSurfaceView  myView;
	private MainRenderer myRenderer;

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		setVolumeControlStream(AudioManager.STREAM_MUSIC);	//音量変更をボリュームボタンでできるようにする

		myView = new MyGLSurfaceView(this);
		myRenderer = new MainRenderer(this);
		myView.setRenderer(myRenderer);						//必ずしもsetRendererはここでやる必要は無いらしい
		setContentView(myView);
	}

	//Activity停止時の処理（途中でアプリからホームに戻った時とか、画面が回転した時の処理）
    @Override
    protected void onPause(){	//今のままだとアプリ途中で別アプリ起動したりということができないのでいずれ修正
    	super.onPause();
    	myView.onPause();

    	//テクスチャを削除する
    	GLTextureManager.DeleteAll(Global.gl);
    	//BGMの削除
    	AndroidBgmManager.DeleteAll();
    	//SEの削除
    	AndroidSoundManager.DeleteAll();
    }

    //Activity復帰時の処理
    @Override
    protected void onResume(){
    	super.onResume();
    	myView.onResume();
    }
}

