//-----------------------------------------------------------------
//Start Class (Task Class 継承)
//ゲームループのスタートに当たる処理を記述するクラス
//Copyright：TOMY
//Ver:1.000
//-----------------------------------------------------------------
package jp.denpa.tomy.games;

import javax.microedition.khronos.opengles.GL10;

import android.content.Context;

import jp.denpa.tomy.opengl_es.wrap.GL2DVertex;
import jp.denpa.tomy.opengl_es.wrap.GLTexture;
import jp.denpa.tomy.opengl_es.wrap.Global;
import jp.denpa.tomy.opengl_es.wrap.MainRenderer;
import jp.denpa.tomy.opengl_es.wrap.MyBgm;
import jp.denpa.tomy.opengl_es.wrap.MySound;
import jp.denpa.tomy.opengl_es.wrap.Vector2;


//インターフェイスを継承して書くメソッドを独自に実装
public class Start implements Task{

	//テスト
	private GL2DVertex[] 	test = new GL2DVertex[2];
	private GLTexture  		tex1 = new GLTexture();
	private GLTexture  		tex2 = new GLTexture();
//	private MySound	   		se1	 = new MySound(R.raw.explosion);
	private MyBgm	   		bgm1 = new MyBgm(R.raw.master1);
	private float a=0;						//色んな動作の確認用（消していいよ）

	@Override
	public void Init() {			//引数の問題は後で直す


	  	//色のブレンド方法
	  	Global.gl.glBlendFunc(GL10.GL_SRC_ALPHA,GL10.GL_ONE_MINUS_SRC_ALPHA);
	    // 深度テストを有効に
	  	Global.gl.glEnable(GL10.GL_DEPTH_TEST);
	 	//テクスチャ機能ON
	  	Global.gl.glEnable(GL10.GL_TEXTURE_2D);
	    //透明可能に
	  	Global.gl.glEnable(GL10.GL_ALPHA_TEST);


	  	bgm1.PlayBgmLoop();


	  	//テクスチャの設定
		tex1.LoadTexture(R.drawable.image_512);
//		tex1.SetTexQuality(gl10,GL10.GL_NEAREST,GL10.GL_NEAREST);

		tex2.LoadTexture(R.drawable.image_128);
//		tex2.SetTexQuality(gl10,GL10.GL_LINEAR,GL10.GL_LINEAR);


		//ポリゴンの設定
		test[0] = new GL2DVertex();
		test[1] = new GL2DVertex();

		test[0].Init();
		test[1].Init();

		// 描画座標とサイズを設定
		test[0].center=new Vector2(MainRenderer.screenW/2,MainRenderer.screenH/2);
		test[0].size=new Vector2(50,50);
		test[1].center=new Vector2(150,150);
		test[1].size=new Vector2(300,300);






//		test[0].SetTurnFlg(false);
//		test[1].SetTurnFlg(false);

	}

	@Override
	public void Work() {
		// TODO 自動生成されたメソッド・スタブ

	}

	@Override
	public void Update() {

		a+=0.005f;
		if(a>(Math.PI*2)){				//ポリゴンが１回転した時
//			se1.PlaySoundOnce();		//効果音のテスト
//			if(bgm1.PlayCheck()){		//BGMが再生されていたら停止、停止していたら再生
//				bgm1.PlayBGMStop();
//			}else{
//				bgm1.PlayBgmLoop();
//			}
			a=0;
			bgm1.PlayBGMStop();
		}



		// テクスチャのUV座標を設定
		test[0].SetUV(2, 2, 1, 1);
//		test.SetColor(1, 1, 0, 0);
		test[0].rad = -a;




		test[1].SetUV(3, 3, 1, 1);
//		test2.SetColor(1, 0, 1, 0);
		test[1].rad = a;


	}

	@Override
	public void Draw() {
//2Dウィンドウ座標系描画設定--------------------------------------------------------
		//ビューポート変換
		Global.gl.glViewport(0,0,MainRenderer.screenW,MainRenderer.screenH);
		//投影変換
		Global.gl.glMatrixMode(GL10.GL_PROJECTION);

		Global.gl.glLoadIdentity();
		Global.gl.glOrthof(0.0f, (float)MainRenderer.screenW, (float)MainRenderer.screenH, 0.0f, 10.0f, -10.0f);	//座標系の指定（最重要:左上原点Wndow座標系指定(ニア、ファーは０にして２D専用にしている)）

		Global.gl.glMatrixMode(GL10.GL_MODELVIEW);
		Global.gl.glLoadIdentity();
		
		Global.gl.glDisable(GL10.GL_DEPTH_TEST);	//zバッファ（深度バッファ）を無効化する(機種ごとのzバッファの精度の差を気にしなくてもいいようにする)

		//zバッファとかリングフラグは一緒に指定できないので一度削除する必要あり
//		Global.gl.glEnable(GL10.GL_CULL_FACE);		//カリングを有効化する
//		Global.gl.glCullFace(GL10.GL_BACK);			//両面描画	
//ここまで--------------------------------------------------------------------------


//描画ゾーン----------------------------------------------------------
		test[0].Draw(tex2.getTexName());
		test[1].Draw(tex1.getTexName());



//ここまで------------------------------------------------------------


	}

	@Override
	public void Release() {

	}

}