//-----------------------------------------------------------------
//AndroidBgmManager Class
//読み込まれたBGMを管理するためのクラス
//Copyright：TOMY & OpenGLで作るAndroidSDKゲームプログラミング(参考って意味で)
//Ver:1.000
//-----------------------------------------------------------------
package jp.denpa.tomy.opengl_es.wrap;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;


import android.media.MediaPlayer;

public class AndroidBgmManager {

	//追加されたBGMを保持する為のリスト（コレクションフレームワーク）(Integer==int)
	private static Map<Integer, MediaPlayer> mBgmMap = new Hashtable<Integer, MediaPlayer>();

	//ロードしたBgmを追加する(再生用のファイルのId, Idが突っ込まれているMediaPlayer変数)
	public static final void AddBgm(int bgmId, MediaPlayer mBgm){
		mBgmMap.put(bgmId,mBgm);			//引数：(キー【名前】、バリュー【値】)
	}

	public static final void DeleteBgm(int bgmId){
		if(mBgmMap.containsKey(bgmId)){
			mBgmMap.get(bgmId).release();
			mBgmMap.remove(bgmId);
		}

	}

	//すべてのBgmを削除する
	public static final void DeleteAll(){
		List<Integer> keys = new ArrayList<Integer>(mBgmMap.keySet());	//mBitMapに入っているキーの一覧を取得
		for(Integer key : keys){
			DeleteBgm(key);			//mBitmapで取得した値の数だけ回してDelete。
		}
	}
}
