//-----------------------------------------------------------------
//GLTexture Class
//テクスチャを読み込み、OpenGLに登録するクラス
//Copyright：TOMY
//Ver:1.000
//-----------------------------------------------------------------
package jp.denpa.tomy.opengl_es.wrap;

import java.util.*;

import javax.microedition.khronos.opengles.GL10;

import jp.denpa.tomy.games.MyGLSurfaceView;
import jp.denpa.tomy.games.R;
//import android.content.Context;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.BitmapFactory;
import android.opengl.GLUtils;


//テクスチャ管理クラス（１枚単位）
public class GLTexture {

	private int textureName;
	private static final BitmapFactory.Options options = new BitmapFactory.Options();

	public static  Vector2 texSize;
//	static {
//		//リソースの自動リサイズをしない
//		options.inScaled = false;
//		//32bit画像として読み込む
//		options.inPreferredConfig = Config.ARGB_8888;
//	}

	//テクスチャの読み込み
	public void LoadTexture(int id){
		//テクスチャに関する処理---------------------------------------
		int[] textures = new int[1];

		//Bitmapの作成
		Bitmap bitmap =	BitmapFactory.decodeResource(Global.context.getResources(), id);	//Bitmapの生成
		if(bitmap == null){textureName=0;}		//生成に失敗したらとりあえず０を突っ込む


		//OpenGL用のテクスチャを生成する
		Global.gl.glGenTextures(1,textures, 0);
		Global.gl.glBindTexture(GL10.GL_TEXTURE_2D, textures[0]);
		GLUtils.texImage2D(GL10.GL_TEXTURE_2D, 0, bitmap, 0);
		Global.gl.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MIN_FILTER, GL10.GL_LINEAR);
		Global.gl.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MAG_FILTER, GL10.GL_LINEAR);

		//テクスチャサイズを取ろうとするとフリーズする(解決の必要あり)
//		texSize.x = (float)bitmap.getWidth();
//		texSize.y = (float)bitmap.getHeight();

		//TextureManagerに登録
		GLTextureManager.AddTexture(id, textures[0]);

		//テクスチャ名を保存する
		textureName = textures[0];

		//OpenGLへの転送が完了したので、VMメモリ上に作成したBitmapを廃棄する
		bitmap.recycle();

		//GLTextureManagerに登録
		GLTextureManager.AddTexture(id, textures[0]);

	}

	//テクスチャの拡大縮小時の画質の設定
	public void SetTexQuality(int MinBorder,int MagBorder){	//引数：1 縮小時の画質設定  2 拡大時の画質設定
		//
		//GL10.GL_NEARESTは処理が早いが画質は悪い
		//GL10.GL_LINEARは処理は遅いが画質は良い
		//拡大縮小時の処理を指定
		Global.gl.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MIN_FILTER, MinBorder);
		Global.gl.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MAG_FILTER, MagBorder);


	}

	public int getTexName(){
		return textureName;
	}

	//開放処理
	public void Release(){}

}


