//-----------------------------------------------------------------
//GLTextureManager Class
//読み込まれたテクスチャを管理するためのクラス
//Copyright：OpenGLで作るAndroidSDKゲームプログラミング(参考って意味で)
//Ver:1.000
//-----------------------------------------------------------------
package jp.denpa.tomy.opengl_es.wrap;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

import javax.microedition.khronos.opengles.GL10;

public class GLTextureManager {

	//テクスチャを保持する（コレクションフレームワーク）(Integer==int)
	private static Map<Integer, Integer> mTextures = new Hashtable<Integer, Integer>();

	//ロードしたテクスチャを追加する
	public static final void AddTexture(int resId, int texId){
		mTextures.put(resId, texId);			//(Androidで作られたテクスチャのId, OpenGL上で作られたテクスチャId)
	}

	//テクスチャを削除する
	public static final void DeleteTexture(GL10 gl, int resId){
		if(mTextures.containsKey(resId)){
			int[] texId = new int[1];
			texId[0] = mTextures.get(resId);
			gl.glDeleteTextures(1,texId, 0);
			mTextures.remove(resId);
		}
	}

	//すべてのテクスチャを削除する
	public static final void DeleteAll(GL10 gl){
		List<Integer> keys = new ArrayList<Integer>(mTextures.keySet());
		for(Integer key : keys){
			DeleteTexture(gl, key);
		}
	}
}
