//-----------------------------------------------------------------
//MySound Class
//BGMとしてメディアファイルを読み込むクラス
//Copyright：TOMY & OpenGLで作るAndroidSDKゲームプログラミング(参考って意味で)
//Ver:1.000
//-----------------------------------------------------------------
//今後の課題
//複数のBGMを一括で管理するものを作り、一括で解放できるようにする（TextureManagerみたいなの）
//今のままだと一ファイルごとにこのクラスのオブジェクトを用意しなければならないので。
//バッググラウンドで再生し続ける問題もあり
//正直このクラス自体いるのか怪しく感じてきた。

package jp.denpa.tomy.opengl_es.wrap;

import android.media.MediaPlayer;

public class MyBgm {
	private MediaPlayer mBgm;

	public MyBgm(int BgmId){
		//BGMファイルを読み込む
		this.mBgm = MediaPlayer.create(Global.context, BgmId);
		//ループ再生ON
		this.mBgm.setLooping(true);
		//左右の音量を最大にする
		this.mBgm.setVolume(1.0f,1.0f);
		
		//マネージャーに登録
		AndroidBgmManager.AddBgm(BgmId,mBgm);
	}

	//BGMのループ再生
	public void PlayBgmLoop(){
		this.mBgm.setLooping(true);
		mBgm.seekTo(0);
		mBgm.start();
	}

	//BGMのループ再生(再生位置指定:ミリ秒)
	public void PlayBgmLoop(int startPos){
		this.mBgm.setLooping(true);
		mBgm.seekTo(startPos);
		mBgm.start();
	}

	//BGMの一回だけ再生
	public void PlayBgmOnce(){
		this.mBgm.setLooping(false);
		mBgm.seekTo(0);
		mBgm.start();
	}

	//BGMの一回だけ再生(再生位置指定:ミリ秒)
	public void PlayBgmOnce(int startPos){
		this.mBgm.setLooping(false);
		mBgm.seekTo(startPos);
		mBgm.start();
	}

	//BGMの一時停止
	public void PlayBgmPause(){
		mBgm.pause();
		mBgm.prepareAsync();				//一時停止でも再生準備のメソッドいるのかな？
	}

	//一時停止状態からの再生
	public void PlayBgmResume(){
		mBgm.start();
	}

	//BGMの停止
	public void PlayBGMStop(){
		if(mBgm.isPlaying()){
			mBgm.stop();
			mBgm.prepareAsync();				//再生準備(無いととっさの再生ができない)
		}
	}
	//音量の変更(最大1.0f)
	public void ChengeVolume(float leftVol, float rightVol){
		mBgm.setVolume(leftVol, rightVol);
	}

	//現在BGMが再生されているのか
	public boolean PlayCheck(){
		if(mBgm.isPlaying()){
			return true;
		}else{
			return false;
		}
	}

	//解放処理(いるのかな？)
	public void Delete(){
		mBgm.release();
	}
}
