//-----------------------------------------------------------------
//MySound Class
//効果音としてメディアファイルを読み込むクラス
//Copyright：TOMY & OpenGLで作るAndroidSDKゲームプログラミング(参考って意味で)
//Ver:1.000
//-----------------------------------------------------------------
//今後の課題
//複数の効果音を一括で管理するものを作り、一括で解放できるようにする（TextureManagerみたいなの）
//今のままだと一ファイルごとにこのクラスのオブジェクトを用意しなければならないので。
//あと、バックグラウンドで再生し続ける問題もあり
//正直このクラス自体いるのか怪しく感じてきた。

package jp.denpa.tomy.opengl_es.wrap;

import jp.denpa.tomy.games.R;			//android.Rじゃなくてこっちじゃないとidの読み込みでエラー
import android.media.*;

public class MySound {
	private SoundPool mSoundPool;	//SoundPool(データをメモリに保持するため負担は大きいが、呼び出し時の遅延は少ない)
	private int mSound;				//読み込んだ効果音オブジェクト
	public MySound(int SoundId){
		//SoundPoolを生成する
		this.mSoundPool = new SoundPool(1,AudioManager.STREAM_MUSIC,0);		//第一引数は読み込むファイルの”数”
		//効果音を読み込む
		this.mSound = mSoundPool.load(Global.context, SoundId,1);
		AndroidSoundManager.AddSound(SoundId, mSoundPool);
	}

	//とりあえず一回だけ再生したい場合
	public void PlaySoundOnce(){
		//効果音の再生
		mSoundPool.play(mSound, 1.0f, 1.0f, 1, 0, 1.0f);
	}

	//玄人向けの詳細な設定をする
	public void PlaySoundLoop(float leftVol, float rightVol, int priority,int loop, float rate){
		//効果音の再生
		mSoundPool.play(mSound,leftVol,rightVol,priority,loop,rate);
	}

	//ループ回数だけ入れる、至極単純なメソッド
	public void PlaySoundLoop(int loop){
		//効果音の再生
		mSoundPool.play(mSound, 1.0f, 1.0f, 1, loop, 1.0f);
	}

	//一時停止
	public void PlaySoundPause(){
		mSoundPool.pause(mSound);
	}

	//再開
	public void PlaySoundResume(){
		mSoundPool.resume(mSound);
	}

	//停止
	public void PlaySoundStop(){
		mSoundPool.stop(mSound);
	}

	//解放(つかうことあるのか？)
	public void Delete(){
		mSoundPool.resume(mSound);
	}
}
